cache-apt-pkgs-action/pre_cache_action.sh

75 lines
1.8 KiB
Bash
Raw Normal View History

#!/bin/bash
# Include library.
script_dir="$(dirname -- "$(realpath -- "${0}")")"
2022-03-26 19:48:16 +00:00
source "${script_dir}/lib.sh"
# Directory that holds the cached packages.
cache_dir="${1}"
# Version of the cache to create or load.
2022-07-20 03:42:48 +00:00
version="${2}"
# List of the packages to use.
input_packages="${@:3}"
# Trim commas, excess spaces, and sort.
packages="$(normalize_package_list "${input_packages}")"
2021-10-22 04:12:42 +00:00
# Create cache directory so artifacts can be saved.
2022-07-20 03:42:48 +00:00
mkdir -p ${cache_dir}
2021-10-22 04:12:42 +00:00
log "Validating action arguments (version='${version}', packages='${packages}')...";
2022-07-20 03:42:48 +00:00
if grep -q " " <<< "${version}"; then
log "aborted"
2022-07-20 03:42:48 +00:00
log "Version value '${version}' cannot contain spaces." >&2
exit 1
fi
2022-06-04 04:04:43 +00:00
# Is length of string zero?
if test -z "${packages}"; then
log "aborted"
2022-07-20 03:42:48 +00:00
log "Packages argument cannot be empty." >&2
exit 2
fi
log "done"
log_empty_line
versioned_packages=""
log "Verifying packages..."
for package in ${packages}; do
if test ! "$(apt-cache show "${package}")"; then
echo "aborted"
2022-07-20 03:42:48 +00:00
log "Package '${package}' not found." >&2
exit 3
fi
2022-07-20 03:42:48 +00:00
read package_name package_ver < <(get_package_name_ver "${package}")
versioned_packages=""${versioned_packages}" "${package_name}"="${package_ver}""
done
log "done"
log_empty_line
# Abort on any failure at this point.
set -e
2022-07-20 03:42:48 +00:00
log "Creating cache key..."
# TODO Can we prove this will happen again?
normalized_versioned_packages="$(normalize_package_list "${versioned_packages}")"
2022-07-20 03:42:48 +00:00
log "- Normalized package list is '${normalized_versioned_packages}'."
2022-07-20 03:42:48 +00:00
value="${normalized_versioned_packages} @ ${version}"
log "- Value to hash is '${value}'."
key="$(echo "${value}" | md5sum | cut -f1 -d' ')"
2022-07-20 03:42:48 +00:00
log "- Value hashed as '${key}'."
log "done"
key_filepath="${cache_dir}/cache_key.md5"
2022-07-20 03:42:48 +00:00
echo ${key} > ${key_filepath}
log "Hash value written to ${key_filepath}"